import java.awt.*;

public class DrawingAdvancedWarship extends DrawingWarship {

    public DrawingAdvancedWarship(int speed, float weight, Color bodyColor, Color dopColor, boolean Helipad,boolean Antenna, boolean Missile,int blockForm) {
        super(speed, weight, bodyColor, 120, 50);
        Warship=new EntityAdvancedWarship(speed,weight,bodyColor,dopColor,Helipad,Antenna,Missile);
        Blocks= GetFormOfBlock(blockForm);
        Blocks.SetBlockCount(2*(int)(Math.random()*3+1));
    }
    public DrawingAdvancedWarship(int speed, float weight, Color bodyColor, Color dopColor, boolean Helipad,boolean Antenna, boolean Missile,IDrawingObjectBlock blockForm) {
        super(speed, weight, bodyColor, 120, 50);
        Warship=new EntityAdvancedWarship(speed,weight,bodyColor,dopColor,Helipad,Antenna,Missile);
        Blocks= blockForm;
    }
    public DrawingAdvancedWarship(EntityWarship warship,IDrawingObjectBlock block){
        super(warship,block);
        Warship = warship;
    }

    @Override
    public void DrawTransport(Graphics g) {

        if (! (Warship instanceof EntityAdvancedWarship))
        {
            return;
        }

        EntityAdvancedWarship advancedWarship  = (EntityAdvancedWarship)Warship;
        Graphics2D g2 = (Graphics2D) g;

        int [] x1 ={_startPosX+25,_startPosX+65,_startPosX+75,_startPosX+25,_startPosX+25};
        int [] y1 ={_startPosY,_startPosY,_startPosY+5,_startPosY+5,_startPosY};
        int [] x2 ={_startPosX+25,_startPosX+75,_startPosX+65,_startPosX+25,_startPosX+25};
        int [] y2 ={_startPosY+45,_startPosY+45,_startPosY+50,_startPosY+50,_startPosY+45};

        if (advancedWarship.Missile)
        {
            g2.setColor(advancedWarship.GetDopColor());
            g2.fillPolygon(x1,y1,5);

            g2.setColor(Color.BLACK);
            g.drawLine(_startPosX + 25, _startPosY + 5 - 5, _startPosX + 65, _startPosY + 5 - 5);
            g.drawLine(_startPosX + 65, _startPosY + 5 - 5,_startPosX + 75, _startPosY + 10 - 5);
            g.drawLine(_startPosX + 75, _startPosY + 10 - 5, _startPosX + 25, _startPosY + 10 - 5);
            g.drawLine(_startPosX + 25, _startPosY + 10 - 5, _startPosX + 25, _startPosY + 5 - 5);

            g2.setColor(advancedWarship.GetDopColor());
            g2.fillPolygon(x2,y2,5);

            g2.setColor(Color.BLACK);
            g.drawLine(_startPosX + 25, _startPosY + 50 - 5,_startPosX + 75, _startPosY + 50 - 5);
            g.drawLine(_startPosX + 75, _startPosY + 50 - 5,_startPosX + 65, _startPosY + 55 - 5);
            g.drawLine(_startPosX + 65, _startPosY + 55 - 5,_startPosX + 25, _startPosY + 55 - 5);
            g.drawLine(_startPosX + 25, _startPosY + 55 - 5,_startPosX + 25, _startPosY + 50 - 5);
        }

        _startPosY += 5;
        super.DrawTransport(g);
        _startPosY -= 5;

        if (advancedWarship.Helipad)
        {
            g2.setColor(advancedWarship.GetDopColor());
            g.fillOval(_startPosX + 85, _startPosY + 20-5, 20, 20);

            g2.setColor(Color.BLACK);
            g.drawOval(_startPosX + 85, _startPosY + 20-5, 20, 20);
            g.drawLine(_startPosX + 90, _startPosY + 25 - 5, _startPosX + 90, _startPosY + 35 - 5);
            g.drawLine(_startPosX + 90+10, _startPosY + 25 - 5, _startPosX + 90+10, _startPosY + 35 - 5);
            g.drawLine(_startPosX + 90, _startPosY + 30 - 5, _startPosX + 100, _startPosY + 30 - 5);
        }
        if (advancedWarship.Antenna)
        {
            g2.setColor(Color.BLACK);
            g.drawLine(_startPosX + 15, _startPosY + 20 - 5, _startPosX + 15, _startPosY + 40 - 5);
            g.drawLine(_startPosX +10, _startPosY + 30 - 5, _startPosX + 20, _startPosY + 30 - 5);
        }
    }
}
