import java.util.ArrayList;
import java.util.Iterator;

public class SetWarshipsGeneric<T extends Object> implements Iterable<T>{
    private final ArrayList<T> _places;

    public int Count() {
        return _places.size();
    }

    private final int _maxCount;

    public SetWarshipsGeneric(int count)
    {
        _maxCount=count;
        _places = new ArrayList<>();
    }

    public int Insert(T warship)
    {
        if (_places.size()+1>=_maxCount)
            return -1;
        _places.add(0,warship);
        return 0;
    }

    public int Insert(T warship, int position)
    {
        if (position>=_maxCount||position<0)
            return -1;
        if (_places.size()+1>=_maxCount)
            return -1;
        _places.add(position,warship);
        return position;
    }

    public T Remove(int position)
    {
        if (position>=_maxCount||position<0)
            return null;
        T deleted=_places.get(position);
        _places.remove(position);
        return deleted;
    }

    public T Get(int position)
    {
        if (position>=_maxCount||position<0)
            return null;
        return _places.get(position);
    }

    public void Set(int position,T warship){
        if (position >= _maxCount||position<0)
            return;
        Insert(warship,position);
    }

    @Override
    public Iterator<T> iterator(){
        return _places.iterator();
    }
}
