import java.awt.*;

public class SimpleMap extends AbstractMap {
    @Override
    protected void DrawWaterPart(Graphics gr, int i, int j) {
        gr.setColor(new Color(0x5285B6));
        gr.fillRect((int) (i * _size_x), (int) (j * _size_y), (int) (i * (_size_x + 1)), (int) (j * (_size_y + 1)));
    }

    @Override
    protected void DrawLandPart(Graphics gr, int i, int j) {
        gr.setColor(new Color(0x422A1D));
        gr.fillRect((int) (i * _size_x), (int) (j * _size_y), (int) (i * (_size_x + 1)), (int) (j * (_size_y + 1)));
    }

    @Override
    protected void GenerateMap() {
        _map = new int[100][100];
        _size_x = (float) (_width / _map.length);
        _size_y = (float) (_height / _map[0].length);
        int counter = 0;
        for (int i = 0; i < _map.length; ++i) {
            for (int j = 0; j < _map[i].length; ++j) {
                _map[i][j] = _freeWaterArea;
            }
        }
        while (counter < 50) {
            int x = _random.nextInt(99);
            int y = _random.nextInt(99);
            if (_map[x][y] == _freeWaterArea) {
                _map[x][y] = _land;
                counter++;
            }
        }
    }
}
